from socket import *
import argparse

from JsonMapper import JsonMapper

ENCODING = "utf-8"


def connect(ipaddr, port):
    host = f"{ipaddr}:{port}"
    print(f"Pripojuji se na {host}")
    sock = socket(AF_INET, SOCK_STREAM)
    sock.connect((ipaddr, port))
    print(f"Pripojeno k {host}")
    return sock


def get_file_content(filepath) -> str:
    f = open(filepath, "r")
    return f.read()


if __name__ == '__main__':
    arg_parser = argparse.ArgumentParser()
    arg_parser.add_argument("-p", "--port", type=int, help="Destination port", required=True)
    arg_parser.add_argument("-f", "--file-path", type=str, help="Path to file", required=True)
    arg_parser.add_argument("-i", "--ip", type=str, help="Destination ip address", default=gethostbyname(gethostname()))
    arg_parser.add_argument("-t", "--testing", help="Testing environment option", action="store_true")

    args = arg_parser.parse_args()

    sock = connect(args.ip, args.port)

    file_content = get_file_content(args.file_path)
    packet = JsonMapper.get_from_api(file_content, args.testing)
    json_sent = packet.to_JSON()

    sock.send(json_sent.encode(ENCODING))

    print(f"Text send to server:\n{json_sent}")
    sock.close()
    print("Spojeni ukonceno")
